/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Auto Zapusk GSM
Version : 
Date    : 16.02.2024
Author  :  ..
Company : Home
Comments:      :   ,   (  
    5    2 )        
4 1 (    -17 .)   4    PORT D4 ( 6)  GND -  
     DS18b20.
  7 .


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 4,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/
#include <mega8.h>
#include <delay.h>                                      // 
#include <ds18b20.h>                                    //     ds18b20


// Declare your global variables here
#define MAX_DS18B20 8
float temp1;// ,temp2;                  //     
unsigned char devices=0;                      //     DS18b20
unsigned char rom_code[2][9];               //     [4][9] 4 .
unsigned int A,B,C,D=0;
unsigned char At,Bt,Ct, Dt=0; 
//int Ct1 = 0;
int znak = 0;                              //    
unsigned int Bt1 = 0;


#define _Tel_OFF 300
#define RX_BUFFER_SIZE 150
#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)
#define _tim_end 60                    //   ds18b20   
#define _timer_perep 61628
#asm
   .equ __w1_port=0x15 ;PORTC           //   
   .equ __w1_bit=5 
#endasm

unsigned char i, rx_cursor; //  ()   
char MyBuffer[RX_BUFFER_SIZE];                          //    SMS    
unsigned int z;                                         //    
flash unsigned char cmd_0[]={"AT+IPR=9600"};            //    UART
flash unsigned char cmd_1[]={"AT"};                     //        ( 0)
flash unsigned char cmd_2[]={"AT+CMGF=1"};              //  SMS  
flash unsigned char cmd_2_[]={"AT+CMGF=0"};             //   
flash unsigned char cmd_3[]={"AT+CMGS="};               //  SMS   
flash unsigned char cmd_4[]={"ATH0"};                   //   ( )
flash unsigned char cmd_5[]={"Temper "};                //  
flash unsigned char cmd_6[]={"Zvonok "};                //  
flash unsigned char cmd_7[]={"Brelok "};                //  
flash unsigned char cmd_9[]={"AT+CLIP=1"};              //     - 
flash unsigned char cmd_10[]={"ATD+ "};                 //    "ATD+ +7xxxxxxxxxx;"  
flash unsigned char cmd_11[]={"Clear Tel"};             //   "   "
flash unsigned char cmd_12[]={"New Tel"};               //   "    "
flash unsigned char cmd_13[]={"AT+CMGDA="};             //  
flash unsigned char cmd_13_[]={"DEL ALL"};              //              SMS.
flash unsigned char cmd_14[]={"\nTem "};               //      "Tem -17"
unsigned char cmd_8[13]={0};                            //   
int _flag = 0;                                          //   SMS  
int Temperat = 0;                                       // .   .   
int _Err = 0;                                           // -      5  ( 2)
int _Err_out = 0;                                       //   -      (=1)
int _Blokir = 0;                                        //     ( pfgecrjv ())  2     3 
int _Tel = 0;                                           //      (  )
int Ring = 0;                                           //    = 4
int Deact = 0;                                          //     -   "DEACT"  Deact==5    GPS 
char _Tel_SMS = 0;                                      //    0=SMS 1=Zvonok
int _tim = 0;                                           //    ds18b20
__eeprom unsigned char cmd_8e[]={"+79123456789"};       //  
__eeprom char _Tel_SMS_E = 0;                           //    0=SMS 1=Zvonok
//=======================================================================
// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Place your code here
_tim++;
TCNT1 = _timer_perep;
}
//------------------------------------------
// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
    { 
    char status, data;
    status=UCSRA;
    data=UDR;
    if ((status & (FRAMING_ERROR | PARITY_ERROR )) ==0) //| DATA_OVERRUN))==0)
      {                                                 

        }
      if (Ring!=4)
        {
        if (data=='R') Ring=1;
        if (data=='I') 
            {
            if (Ring==1) Ring++;
            else  Ring=0;
            }            
        if (data=='N')
            {
            if (Ring==2) Ring++;
            else  Ring=0;
            }
        if (data=='G')
            {
            if (Ring==3) Ring++;                    // Ring = 4   
            else  Ring=0;
            }
        }
      if (Deact!=5)
        {
        if (data=='D') Deact=1;                        //     -   "DEACT"  
        if (data=='E')                                 //  Deact==5    GPS 
            {
            if (Deact==1) Deact++;
            else  Deact=0;
            }        
        if (data=='A') 
            {
            if (Deact==2) Deact++;
            else  Deact=0;
            }        
        if (data=='C') 
            {
            if (Deact==3) Deact++;
            else  Deact=0;
            } 
        if (data=='T') 
            {
            if (Deact==4) Deact++;
            else  Deact=0;
            }       

        if((data==0x0d)||(data==0x0a))
            {
            if(i>0)
                {
                data = 0;
                }
            }
        MyBuffer[i]=data;
        i ++;                                       //                                        
        if (i == RX_BUFFER_SIZE)                    //     
            {                                       //     
            i=0;                                    //   = 0
            }
        
      }
    }  
//-----------------------------------------------------------------
// Analog Comparator interrupt service routine
//-----------------------------------------------------------------
interrupt [ANA_COMP] void ana_comp_isr(void)
{
// Place your code here
//if (PIND.4==0) 
Temperat = 1;                        //  D4 = Gnd   -4 1   DS18b20 
}
//=================================================================
//-----------------------------------------------------------------
//     SMS
void chislo( int cislo)                             //                                                 
    {                                               //  -  D C B A 
    A = B = C  = cislo;
    C = C / 100 ;                                   //    (  100)
    B = A = B % 100 ;                               //     100
    B = B / 10 ;                                    //    (  10)  
    A = A % 10 ;                                    //     (     10)
 
    if (znak>0) D=0x2d;
    else D = '+';
    if (C==0)                                       //       (  )   
        { 
        C=D;
        D=0x20;
        }                           

    Dt=D;
    if (C<10) Ct=C|0x30;
    else Ct=C;
    Bt=B|0x30;
    At=A|0x30;  
    }
//-------------------------------------------------------------
//-------------    DS18b20 --------------
//-------------------------------------------------------------
void _Temper(void)                                  //      
    { 

    if (devices==0)
        {
        devices=w1_search(DS18B20_SEARCH_ROM_CMD,rom_code);             //        1-Wire 
        ds18b20_init(0,-35,35,DS18B20_12BIT_RES);//DS18B20_12BIT_RES);  //    12  
        delay_ms(500);
        }
    else {
        temp1 = ds18b20_temperature(&rom_code[0][0]);  //     
        if ((temp1 < 100) & (temp1 > -60))      //    
            { 
            //temp1= temp1;
            if (temp1>0)znak=0;                 //    - (   znak=1)
            else znak=1;
            temp1=temp1*10;                     //   (             
            if (znak==1) 
                {
                temp1 = -temp1;                 //         
                //if ((PIND.4==1) & (temp1>160)) Temperat = 1;     //  D4 = 1  DS18b20     -16"C     
                if (temp1>160) Temperat = 1;     //  D4 = 1  DS18b20     -16"C   
                }
            Bt1 = (int) temp1;         
            chislo(Bt1);                        //        
            } 
        } 
    }
//-----------------------------------------------------------------
//-------       ----------
//-----------------------------------------------------------------
int AON_(void)                                      
    { char y, x =0; 
    rx_cursor = 0;                                  //   (    UART)
    delay_ms(1000);                                 //       
    x = i;                          
    #asm("cli")                                     //  
    i = 0;                                          //   UART 
    #asm("sei")                                     //      
    if (x==0) return 0;                             //   -   
    y=0;   

    for ( rx_cursor=0;rx_cursor!=x;rx_cursor++)                                                                             
        {
        if (y==12) return 1;                        //       
        if (rx_cursor==RX_BUFFER_SIZE) return 0;    //   -  
        if (cmd_8[y]==MyBuffer[rx_cursor])
            {
            y++;
            }
        }
    if (y<12) return 0;                             //    (   )
    }
//-----------------------------------------------------------------
//------------   ( ) --------------------
//-----------------------------------------------------------------
void Otboy(void)                                    
    {

    for(z=0;cmd_4[z]!='';z++)                       //  
        {
        UDR = cmd_4[z];
        delay_ms(100);
        }
    UDR = ('\r');
    delay_ms(1500);    
    } 
//----------------------------------------------------------
//-----------   SMS ------------------------------
//----------------------------------------------------------
void Dell_SMS(void)                                 //   SMS "AT+CMGDA=DEL ALL"
    {

    PORTC.3 = 1;                                    //   SMS
    for(z=0;cmd_1[z]!='';z++)                       //     
        {
        UDR = cmd_1[z];
        delay_ms(100);
        }
    UDR = ('\r');                                   //   ()
    delay_ms(500);

    for(z=0;cmd_13[z]!='';z++)                       //  SMS  
        {
        UDR = cmd_13[z];
        delay_ms(100);
        }
    UDR = ('"');
    delay_ms(100);
    for(z=0;cmd_13_[z]!='';z++)                     //    SMS ( AT+CMGDA=DEL ALL )
        {
        UDR = cmd_13_[z];
        delay_ms(100);
        }
    UDR = ('"');
    delay_ms(100);
    UDR = ('\r');                                   //   ()


    delay_ms(1500);  
    for(z=0;cmd_2_[z]!='';z++)                      //   
        {
        UDR = cmd_2_[z];                                                                                                
        delay_ms(100);
        }
    UDR = ('\r');                                   //   ()
    delay_ms(500);

    if (_flag==1)    PORTC.3 = 1;                   //     SMS     
    else PORTC.3 = 0;
    }  
//----------------------------------------------------------
//-------------   GSM Sim800L --------------
//----------------------------------------------------------
void _Start_telef(void)
    { int i; 
//   
PORTB.3 = 0;                                        //   GSM Sim800L                            
for (i=0;i<2;i++)                            
    {                                               // 1   Reset = 0
    PORTC.1 = 1;
    delay_ms (100);
    PORTC.2 = 1;
    delay_ms (100);
    PORTC.3 = 1;
    delay_ms (100);
    PORTC.1 = 0; 
    delay_ms (100);
    PORTC.2 = 0;
    delay_ms (100);
    PORTC.3 = 0;
    delay_ms (100);
    }
PORTB.3 = 1;                                        //  Reset  GSM   Res = 1
for (i=0;i<50;i++)
    {                                               //  20    
    PORTC.3 = 1;
    delay_ms (100);
    PORTC.3 = 0;
    PORTC.2 = 1;
    delay_ms (100);
    PORTC.2 = 0;
    PORTC.1 = 1;
    delay_ms (100);
    PORTC.1 = 0;
    delay_ms (100);
    }
    for(z=0;cmd_1[z]!='';z++)                       //     
        {
        UDR = cmd_1[z];
        delay_ms(100);
        }
    UDR = ('\r');
    delay_ms(500);
    for(z=0;cmd_0[z]!='';z++)                       //    UART
        {
        UDR = cmd_0[z];
        delay_ms(100);
        }
    UDR = ('\r');
    delay_ms(500);
    for(z=0;cmd_9[z]!='';z++)                       //     - 
        {
        UDR = cmd_9[z];
        delay_ms(100);
        }
    UDR = ('\r');        
    delay_ms(500); 
    }
//-------------------------------------------------------------
//------------- SMS------------------------------------                                                           
//-------------------------------------------------------------
void sms_out (void)                                 //  SMS
    {
    PORTC.3 = 1;                                    //   SMS
    _Temper();                                      //       ( )

    for(z=0;cmd_1[z]!='';z++)                       //     
        {
        UDR = cmd_1[z];
        delay_ms(100);
        }
    UDR = ('\r');                                   //   ()
    delay_ms(500);
    for(z=0;cmd_2[z]!='';z++)                       //  SMS  
        {
        UDR = cmd_2[z];
        delay_ms(100);
        }
    UDR = ('\r');                                   //   ()
    delay_ms(500);

    for(z=0;cmd_3[z]!='';z++)                       //  SMS   
        {
        UDR = cmd_3[z];
        delay_ms(100);
        }
    UDR = ('"');
    delay_ms(100);
    for(z=0;cmd_8[z]!='';z++)                       //   
        {
        UDR = cmd_8[z];
        delay_ms(100);
        }
    UDR = ('"');
    delay_ms(100);
    UDR = ('\r');                                   //   ()
    delay_ms(1000);                                 //      SMS ( )
    if (_flag == 0)                                 // SMS - "Temper"
        {
    
        for(z=0;cmd_5[z]!='';z++)                   //   SMS
            {
            UDR = cmd_5[z];
            delay_ms(100);
            }
        } 
    if (_flag == 1)                                 // SMS - "Zvonok"
        {
    
        for(z=0;cmd_6[z]!='';z++)                   //   SMS
            {
            UDR = cmd_6[z];
            delay_ms(100);
            }
        }
    if (_flag == 2)
        {                                           // SMS - "Brelok"
        for(z=0;cmd_7[z]!='';z++)                   //   SMS
            {
            UDR = cmd_7[z];
            delay_ms(100);
            }
        }
    if (_flag == 3)
        {                                           // SMS - "Clear Tel"          
        for(z=0;cmd_11[z]!='';z++)                  //   SMS
            {
            UDR = cmd_11[z];
            delay_ms(100);
            }
        }
    if (_flag == 4)
        {                                           // SMS - "New Tel"             
        for(z=0;cmd_12[z]!='';z++)                  //   SMS
            {
            UDR = cmd_12[z];
            delay_ms(100);
            }
        }  
    if ((_flag<3)&(devices!=0))                         //  SMS   (, , )      
        {
        for(z=0;cmd_14[z]!='';z++)                      //   SMS   " Tem "
            {
            UDR = cmd_14[z];
            delay_ms(100);
            }
        UDR = (Dt);                                      //      
        delay_ms(100);
        UDR = (Ct);
        delay_ms(100);    
        UDR = (Bt);
        delay_ms(100);
        UDR = (',');
        delay_ms(100);
        UDR = (At);
        delay_ms(100);
        UDR = ('"');
        delay_ms(100);
        UDR = ('C');
        delay_ms(100);
        }
    UDR = (26);                                     // ctrlZ->      0x1A
    delay_ms(1500);  
//    for(z=0;cmd_2_[z]!='';z++)                      //   
//        {
//        UDR = cmd_2_[z];                                                                                                
//        delay_ms(100);
//        }
//    UDR = ('\r');                                   //   ()
//    delay_ms(500);


//    Dell_SMS();
    
    for(z=0;cmd_2_[z]!='';z++)                      //   
        {
        UDR = cmd_2_[z];                                                                                                
        delay_ms(100);
        }
    UDR = ('\r');                                   //   ()
    delay_ms(500);
    if (_flag==1)    PORTC.3 = 1;                   //     SMS     
    else PORTC.3 = 0;
    }  
//-------------------------------------------------------------
//-------------  -------------------------------
//-------------------------------------------------------------
void Zvonok(void)
    {  int r; 
    PORTC.3 = 1;                                    //   SMS
//#asm("cli")
    for(z=0;cmd_1[z]!='';z++)                       //     
        {
        UDR = cmd_1[z];
        delay_ms(100);
        }
    UDR = ('\r');                                   //   ()
    delay_ms(500);
    for(z=0;cmd_2_[z]!='';z++)                      //   
        {
        UDR = cmd_2_[z];                                                                                                
        delay_ms(100);
        }
    UDR = ('\r');                                   //   ()
    delay_ms(500);

    for(z=0;cmd_10[z]!='';z++)                      //     
        {
        UDR = cmd_10[z];
        delay_ms(100);
        }

    for(z=0;cmd_8[z]!='';z++)                       //   
        {
        UDR = cmd_8[z];
        delay_ms(100);
        }
    UDR = (';');
    delay_ms(100);
    UDR = ('\r');                                   //   ()
    delay_ms(1000);                                 //   ( )

    for (r=0;r<100;r++) 
        {
        delay_ms (150);                             //   15   
        if (PINC.4==1)  {r=3000; _Err_out=1;}       //    -  
        if (PIND.3==1)  {r=3000; _Err_out=1;}       //    -    
        if (PIND.5==0)  {r=3000; _Err_out=1; _Blokir = 1;}   //     (  )
        }
    
    Otboy();                                        //   (  )

    if (_flag==1)    PORTC.3 = 1;                   //     SMS     
    else PORTC.3 = 0;
    }
//-------------------------------------------------------------
//------------- --------------------------------
//-------------------------------------------------------------
void Zapusk(void)
    { unsigned int k; int t=0; int r=0;
    _Err_out=0;                                     //  
    if (_Err<2) PORTB.0 = 1;                        //     2  
    for (t=0;t<20;t++)
        {
        delay_ms (100);
        if (PINC.4==1) {t=30; _Err_out=1;}
        if (PIND.3==1) {t=30; _Err_out=1;}
        } 
    if ((_Err<2)&&(_Err_out==0))
      for (k=0;k<42000;k++)                         //  7   
        { 
        #asm("wdr");                                //                             
        if (_Err>1) {k=50000; _Err_out=1; _Blokir = 1;}     //  2    -   
        if (PINC.4==1) {k=50000; _Err_out=1;}       //   -  
        if (PIND.3==1) {k=50000; _Err_out=1;}       //   -  
        if ((PIND.5==0)&&(_Err<2))                  //    -      2   =  
            { int f;
            r++;                                    //     
            if (r>2) {k=50000; _Err_out=1;}         //     (  )-  2 
            for (f=0;f<402;f++)                     // 4   
                {
                if ((PIND.3==0)&&(PINC.4==0))       //    
                    {
                    if (k<42000) PORTB.1 = 1;       //    7  (  )   
                    else         
                        {
                        PORTB.1 = 0;                //  
                        PORTB.0 = 0;                //  
                        k=50000;                    //      7 
                        f=410;                      //       4 
                        }
                    }
                else                                //            
                    { 
                    PORTB.1 = 0;                    //  
                    PORTB.0 = 0;                    //  
                    k=50000;                        //      7 
                    f=410;                          //       4 
                    }
                if (f>400) 
                    {
                    PORTB.1 = 0;                    //  
                    _Err++;                         //     -   
                    if (_Err>1) f=410;              //   2 (  )   
                    else f=0;
                    for (t=0;t<60;t++)
                        {
                        delay_ms (100);             //    6 
                        if (PINC.4==1) {t=70; _Err_out=1;}      //  
                        if (PIND.3==1) {t=70; _Err_out=1;}      //   
                        if (Ring==4)                //   
                            { 
                            Ring=0;                 //   
                            _Tel = AON_();          //      
                            Otboy();                //   ( )
                            if (_Tel==1) 
                                {
                                t=70;
                                _Err_out=1;
                                }                                  
                            } 
                        }
                    } 
                if (PIND.5==1)                      //   ,  ()   
                  {
                    f=410;
                    PORTB.1 = 0;                    //  
                    _Err_out = 0;                   //   -   
                    _Err = 0;                       //   -  -    
                    
                    if (_Tel_SMS==0) sms_out();       //  SMS ( ) 
                    else Zvonok();                  //    15  ( ) 
                    if (_Err_out>0) 
                        {
                        k=50000;                    //     (   )  _Err++;  
                        _Err_out = 0; 
                        }                           //   -   
                    else 
                        { 
                        _Err = 0;
                        Temperat = 0;
                        PORTB.2 = 1;                //  
                        delay_ms (500);
                        PORTB.2 = 0;
                        delay_ms (500);
                        PORTB.2 = 1;
                        delay_ms (500);
                        PORTB.2 = 0;
                        }
                  } 
                delay_ms (10);    
                }
            }                                                                                                    
        if (Ring==4)                                // ----   ( ) ----                 
                {
                Ring=0;                             //   
                _Tel = AON_();                      //      
                Otboy();                            //   ( )
                if (_Tel==1) 
                    {
                    _Err_out=1;
                    k=50000;
                    
                    delay_ms (500);                 //    
                    }
                } 
        delay_ms (10);
        } 
    PORTB.0 = 0;                                    //  
    PORTB.1 = 0;                                    //       
    PORTC= (1<<PORTC5) | (1<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0); // Led -   ( ) Off  
 //   PORTC.4 = 1;
    Temperat=0;                                     //    
//    #asm("sei")                                   //  
    } 
//-------------------------------------------------------------------------------------
//----      (   5   5 ) ----
//-------------------------------------------------------------------------------------
void Priviazka_tel(void)                            //      (   5   5 )  
    {  char Ring2, y, x =0; 
    if (cmd_8e[0]=='+')                             //     (    +)   SMS      
        {
        _flag = 3;                                  //  SMS "Clear Tel"
        sms_out();                                  //  SMS    
        cmd_8[0]=cmd_8e[0]=0;                       //  +    (  )      
        }
    PORTC.2 = 1;                                    // Led    
    if (Ring==4)                                    //                                                         
        { 
        PORTC.1 = 1;                                // Led    
        delay_ms (1000); 
        Ring=0;                                     //     
        Otboy();                                    //   
        if (i==0) return;                           //     -    
        x=i;
        #asm("cli")                                 //  
        i = 0;                                      //   UART   

        for ( rx_cursor=0;rx_cursor!=x;rx_cursor++)
            { PORTC.2 = 1;
            y = MyBuffer[rx_cursor];
            if (y=='R') Ring2=1;
            if (y=='I') 
                {
                if (Ring2==1) Ring2++;
                else  Ring2=0;
                }            
            if (y=='N')
                {
                if (Ring2==2) Ring2++;
                else  Ring2=0;
                }
            if (y=='G')
                {
                if (Ring2==3) Ring2++;              // Ring = 4   
                else  Ring2=0;
                }
            if (Ring2==4)
                { 
                rx_cursor=rx_cursor+13;             //  RING   13     
                for (z=0;z<13;z++)                  
                    {
                    cmd_8[z] = cmd_8e[z] = MyBuffer[rx_cursor];      //       EEProm   
                    rx_cursor++;
                    if (z==12) 
                        { 
                        cmd_8[z] = cmd_8e[z] = 0;
                        _flag = 4;                  //  SMS "New Tel"
                        delay_ms (1000);
                        sms_out();                  //  SMS   
                        PORTC.3 = 1;                // Led    
                        delay_ms (500);             
                        PORTC=(1<<PORTC5) | (1<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0); 
                        #asm("sei")                 //   
                        return;                     //    
                        }
                    }
                }
            }
        }  
    }

//=====================================================================
void main(void)
{  
// Declare your local variables here
//-----------------------
// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/2048k
#pragma optsize-
//WDTCR=0x1F;                // OSC/2048k
//WDTCR=0x0F;                // 1   2 
WDTCR = (1<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0);   // OSC/2048k
WDTCR = (0<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0);   // 1   2 

// WDTCR = (1<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0);   // OSC/1024k
// WDTCR = (0<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0);   // 1   1 

//-----------------------
// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=In Bit6=In Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out 
DDRB=(0<<DDB7) | (0<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
// State: Bit7=T Bit6=T Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0 
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=In Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=In 
DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (1<<DDC3) | (1<<DDC2) | (1<<DDC1) | (0<<DDC0);
// State: Bit6=T Bit5=T Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=T 
PORTC=(0<<PORTC6) | (1<<PORTC5) | (1<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

// Port D initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
// State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (1<<PORTD5) | (1<<PORTD4) | (1<<PORTD3) | (1<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
//------------------------------
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=(0<<CS02) | (0<<CS01) | (0<<CS00);
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 3,906 kHz
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (0<<CS22) | (0<<CS21) | (0<<CS20);
TCNT2=0x00;
OCR2=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
//TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (0<<TOIE0);
// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;
//----------------------------------------
// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
//----------------------------------------
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
//UCSRA=0x00;
//UCSRB=0x98;  //0x08;                              //        0x98; // ( )              
//UCSRB=(0<<RXEN)|( 1<<TXEN);                       //      USART 
//UCSRC=0x86;                                       //    AtMega8
//UBRRH=0x00;
//UBRRL=0x19;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600

UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;
//----------------------
// Analog Comparator initialization
// Analog Comparator: On
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
// Interrupt on Rising Output Edge
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=(0<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (1<<ACIE) | (0<<ACIC) | (1<<ACIS1) | (1<<ACIS0);
SFIOR=(0<<ACME);

// ADC initialization
// ADC disabled
ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
//----------------------------------------
// SPI initialization
// SPI disabled
SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);
//----------------------------------------
// TWI initialization
// TWI disabled
TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);
//========================================
if (devices==0)
        {
        devices=w1_search(DS18B20_SEARCH_ROM_CMD,rom_code);             //        1-Wire 
        ds18b20_init(0,-35,35,DS18B20_12BIT_RES);//DS18B20_12BIT_RES);  //    12  
        delay_ms(500);
        }
_Start_telef();
#asm("cli")                                         //  
i = 0;                                              //   UART 
#asm("sei")                                         //      
if (cmd_8e[0]!='+') Priviazka_tel();                //      (     +)
for(z=0;z<13;z++)                                   //     EEProm
        { 
        cmd_8[z] = cmd_8e[z];                       //     EEProm  
        }
_Tel_SMS = _Tel_SMS_E;                              //     SMS  
if (_Tel_SMS>1) _Tel_SMS_E=_Tel_SMS=0;              //   0  1
                             
//----------------------------------------------
// Global enable interrupts
#asm("sei")
PORTD.2 = 0;
while (1)  //   
   {   int t1,t2,t3,t4=0;
   _Err = 0;                                        //    
//-----------------------      -----------------  
   if (PIND.5==1)                                   //   
     { 
     #asm("cli") 

     for (;PIND.5==1;)                              //       
        { 
        #asm("wdr");                                //   
   

        PORTB.0 = 0;                                //      (     )
        PORTB.1 = 0;                                //             
        if (PINC.4==1)  PORTB.2 = 1;                //         
        else            PORTB.2 = 0;                //   
        if ((PIND.3==1)&(PINC.0==1))               // = Drive      
            {
            PORTC.2 = 1;
            for (;PINC.0==1;) delay_ms (100);       //   
            for (i=0;i<100;i++)                      //      5 
                {
                 
                if (PINC.0==1)   
                    {                 
                    if (_Tel_SMS==0) _Tel_SMS_E=_Tel_SMS=1; //     SMS=0  =1
                    else             _Tel_SMS_E=_Tel_SMS=0;
                    i=65;
                    }
                delay_ms (50);
                }
           PORTC.2 = 0;  
           _Start_telef();                         //          Sim800L  GSM
             
           }        
        } 
        _Blokir = 0;                                //      
        Temperat = 0;                               //     (  )
      }
      //-----------------------------------------------------  
   else { 
        #asm("sei")                                           //    (  )
        PORTB.2 = 0;                                //   
//---------- ------------------------------------
   if (PIND.3==1)                                //          -     
     { 
     if (cmd_8[0]!='+')  Priviazka_tel();        //           +
        if (PINC.4==0) 
            {                         //    5    5             
            for (t1=0;t1<5;t1++)
                {
                for (t2=0;t2<40;t2++)
                    {
                    if (PINC.4==0) delay_ms (25);
                    else 
                        {
                        for (t3=0;t3<40;t3++)
                            {
                            if (PINC.4==1) delay_ms (25);
                            else 
                                {
                                t4++;
                                t3=t2=41;
                                
                                }
                            }                
                        }
                    }
                } 
            if (t4>4) Priviazka_tel();              //      (   5   5 )
            }
     } 
   //------------------------------------------------------
        delay_ms (500);                                  
        if ((PINC.4==0)&&(PIND.3==0))               // ====        ====       
            {                                       //   :
//-------------    ----------------------------
//            if (PIND.4==1)  
            if (_tim == _tim_end)                        //    DS18b20   60 
                {
                _tim = 0;
                PORTC.1 = 1;
                _Temper();
                PORTC.1 = 0;
                }
            if (Temperat==1) 
                {                                   // ----   -17   ----
                if (_Blokir==0)  
                        { 
                        _flag = 0;                  //  SMS "Temperat"
                        PORTC.1 = 1;                // Led   
                        Zapusk();
                        PORTC.1 = 0;
                        }
                }
//-------------    ----------------------------
            if (Deact==5)                           //     -   "DEACT"
                {              
                Deact=0;
                _Start_telef();                     //  Deact==5( )    GPS  
                }                                   
            if (Ring==4)                            //  Ring==4( )   ()
                {
                Ring=0;                             //   
                if(_Blokir==0)                      // ----      ( ) ----  
                    { 
                    _Tel = 0;
                    _Tel = AON_();                  //      
                    Otboy();                        //   ( )
                    if (_Tel==1)                    //  ""    
                        { 
                        PORTC.3 = 1;
                        _flag = 1;                  //  SMS "Zvonok"
                        Zapusk();
                        _Tel = 0;
                        PORTC.3 = 0;                // Led    Off   
                        }
                    }
                }  
//-------------    ----------------------------
            if (PINC.0==1)                          // ----   ( ) ----
                { int i=0; int r=0; 
                for (;PINC.0==1;) delay_ms (100);   //     
                 
                for (i=0;i<6;i++)                  
                    {                               //      2  (  )
                    if (r==0)
                        {
                        PORTC.2 = 1;
                        r=1;
                        }
                    else 
                        {
                        PORTC.2 = 0;
                        r=0;
                        }; 
                    delay_ms (330);
                    };                         
                for (i=0;i<20;i++)              //  3      
                    { 
                    #asm("wdr");                //   
                    if (r==0)
                        {
                        PORTC.2 = 1;
                        r=1;
                        }
                    else 
                        {
                        PORTC.2 = 0;
                        r=0;
                        }; 
                    delay_ms (150); 
                    if (PINC.0==1)              //        3   
                        {
                        _flag = 2;              //  SMS "Brelok"
                        for (;PINC.0==1;) delay_ms (100);  //     
                        PORTC.2 = 1;            // Led   
                        _Err = 0;               //   
                        i=31;                   //   
                        _Blokir=0;
                        Zapusk();
                        PORTC.2 = 0;
                        };
                    };
                };
            };
        
        }; 

    };
}
